<template>
  <div class="w-96 mx-auto p-4 rounded shadow-lg bg-white space-y-4">
    <h1 class="text-2xl text-blue-600">Todo List</h1>

    <form class="flex items-end space-x-2" @submit.prevent="createTodo">
      <label for="content" class="grid flex-1">
        <span class="text-sm text-gray-700">Write your todo here</span>
        <input
          type="text"
          id="content"
          name="content"
          placeholder="Walk the dog.."
          class="px-2 py-1 border rounded placeholder-gray-300"
          v-model="data.newTodoContent"
        />
      </label>
      <button
        type="submit"
        class="px-2 py-1 rounded border border-blue-500 bg-blue-500 text-white"
      >
        Add todo
      </button>
    </form>

    <p
      class="text-center text-sm font-extralight italic text-gray-400"
      v-if="!data.todos.length"
    >
      There are no more todos.
    </p>

    <ul v-else class="flex flex-col space-y-3">
      <TodoItem
        v-for="todo in data.todos"
        :key="todo.id"
        :todo="todo"
        :toggleTodo="toggleTodo"
        :deleteTodo="deleteTodo"
      />
    </ul>
  </div>
</template>

<script>
import { onMounted, reactive } from 'vue'
import { api } from '../services/api'
import TodoItem from './TodoItem.vue'

export default {
  components: {
    TodoItem,
  },
  setup() {
    const data = reactive({
      newTodoContent: '',
      todos: [],
    })

    onMounted(() => {
      api.get('todos').then(response => {
        data.todos = response.data
      })
    })

    async function createTodo() {
      const newTodo = {
        id: Date.now(),
        isDone: false,
        content: data.newTodoContent,
      }

      data.todos.push(newTodo)
      data.newTodoContent = ''

      await api.post('todos', {
        ...newTodo,
      })
    }

    async function toggleTodo(todo) {
      todo.isDone = !todo.isDone

      await api.patch(`todos/${todo.id}`, {
        isDone: todo.isDone,
      })
    }

    async function deleteTodo(id) {
      data.todos = data.todos.filter(todo => todo.id !== id)

      await api.delete(`todos/${id}`)
    }

    return {
      data,
      createTodo,
      toggleTodo,
      deleteTodo,
    }
  },
}
</script>
